<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IncomeOfKu StructType
 * @subpackage Structs
 */
class IncomeOfKu extends AbstractStructBase
{
    /**
     * The income_of_ku
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $income_of_ku;
    /**
     * The by_heating
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_heating;
    /**
     * The by_electro
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_electro;
    /**
     * The by_gaz
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_gaz;
    /**
     * The by_hot_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_hot_water;
    /**
     * The by_cold_water
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_cold_water;
    /**
     * The by_sewerage
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $by_sewerage;
    /**
     * Constructor method for IncomeOfKu
     * @uses IncomeOfKu::setIncome_of_ku()
     * @uses IncomeOfKu::setBy_heating()
     * @uses IncomeOfKu::setBy_electro()
     * @uses IncomeOfKu::setBy_gaz()
     * @uses IncomeOfKu::setBy_hot_water()
     * @uses IncomeOfKu::setBy_cold_water()
     * @uses IncomeOfKu::setBy_sewerage()
     * @param float $income_of_ku
     * @param float $by_heating
     * @param float $by_electro
     * @param float $by_gaz
     * @param float $by_hot_water
     * @param float $by_cold_water
     * @param float $by_sewerage
     */
    public function __construct($income_of_ku = null, $by_heating = null, $by_electro = null, $by_gaz = null, $by_hot_water = null, $by_cold_water = null, $by_sewerage = null)
    {
        $this
            ->setIncome_of_ku($income_of_ku)
            ->setBy_heating($by_heating)
            ->setBy_electro($by_electro)
            ->setBy_gaz($by_gaz)
            ->setBy_hot_water($by_hot_water)
            ->setBy_cold_water($by_cold_water)
            ->setBy_sewerage($by_sewerage);
    }
    /**
     * Get income_of_ku value
     * @return float|null
     */
    public function getIncome_of_ku()
    {
        return $this->income_of_ku;
    }
    /**
     * Set income_of_ku value
     * @param float $income_of_ku
     * @return \StructType\IncomeOfKu
     */
    public function setIncome_of_ku($income_of_ku = null)
    {
        // validation for constraint: float
        if (!is_null($income_of_ku) && !(is_float($income_of_ku) || is_numeric($income_of_ku))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($income_of_ku, true), gettype($income_of_ku)), __LINE__);
        }
        $this->income_of_ku = $income_of_ku;
        return $this;
    }
    /**
     * Get by_heating value
     * @return float|null
     */
    public function getBy_heating()
    {
        return $this->by_heating;
    }
    /**
     * Set by_heating value
     * @param float $by_heating
     * @return \StructType\IncomeOfKu
     */
    public function setBy_heating($by_heating = null)
    {
        // validation for constraint: float
        if (!is_null($by_heating) && !(is_float($by_heating) || is_numeric($by_heating))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_heating, true), gettype($by_heating)), __LINE__);
        }
        $this->by_heating = $by_heating;
        return $this;
    }
    /**
     * Get by_electro value
     * @return float|null
     */
    public function getBy_electro()
    {
        return $this->by_electro;
    }
    /**
     * Set by_electro value
     * @param float $by_electro
     * @return \StructType\IncomeOfKu
     */
    public function setBy_electro($by_electro = null)
    {
        // validation for constraint: float
        if (!is_null($by_electro) && !(is_float($by_electro) || is_numeric($by_electro))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_electro, true), gettype($by_electro)), __LINE__);
        }
        $this->by_electro = $by_electro;
        return $this;
    }
    /**
     * Get by_gaz value
     * @return float|null
     */
    public function getBy_gaz()
    {
        return $this->by_gaz;
    }
    /**
     * Set by_gaz value
     * @param float $by_gaz
     * @return \StructType\IncomeOfKu
     */
    public function setBy_gaz($by_gaz = null)
    {
        // validation for constraint: float
        if (!is_null($by_gaz) && !(is_float($by_gaz) || is_numeric($by_gaz))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_gaz, true), gettype($by_gaz)), __LINE__);
        }
        $this->by_gaz = $by_gaz;
        return $this;
    }
    /**
     * Get by_hot_water value
     * @return float|null
     */
    public function getBy_hot_water()
    {
        return $this->by_hot_water;
    }
    /**
     * Set by_hot_water value
     * @param float $by_hot_water
     * @return \StructType\IncomeOfKu
     */
    public function setBy_hot_water($by_hot_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_hot_water) && !(is_float($by_hot_water) || is_numeric($by_hot_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_hot_water, true), gettype($by_hot_water)), __LINE__);
        }
        $this->by_hot_water = $by_hot_water;
        return $this;
    }
    /**
     * Get by_cold_water value
     * @return float|null
     */
    public function getBy_cold_water()
    {
        return $this->by_cold_water;
    }
    /**
     * Set by_cold_water value
     * @param float $by_cold_water
     * @return \StructType\IncomeOfKu
     */
    public function setBy_cold_water($by_cold_water = null)
    {
        // validation for constraint: float
        if (!is_null($by_cold_water) && !(is_float($by_cold_water) || is_numeric($by_cold_water))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_cold_water, true), gettype($by_cold_water)), __LINE__);
        }
        $this->by_cold_water = $by_cold_water;
        return $this;
    }
    /**
     * Get by_sewerage value
     * @return float|null
     */
    public function getBy_sewerage()
    {
        return $this->by_sewerage;
    }
    /**
     * Set by_sewerage value
     * @param float $by_sewerage
     * @return \StructType\IncomeOfKu
     */
    public function setBy_sewerage($by_sewerage = null)
    {
        // validation for constraint: float
        if (!is_null($by_sewerage) && !(is_float($by_sewerage) || is_numeric($by_sewerage))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($by_sewerage, true), gettype($by_sewerage)), __LINE__);
        }
        $this->by_sewerage = $by_sewerage;
        return $this;
    }
}
